; NOTE:
; Previous my testings I complete with NOT-CASE-TOLERANT Lingo's proc.
; In this test, I use new Lingo's proc, which is case tolerant, as my (Alex's - Axhex2dw)
; So, please, test it, and say me timings.
; You may change the string length, or its case, and see results and timings also.
;
; And, if I don't bothered to you, comment next macro, and test also:
UseFastestVariant EQU 1
; If this macro is defined, used more speedy and slightly longer Axhex2dw proc,
; if macro is not defined, used shortes and slightly slower proc.

.nolist
include \masm32\include\masm32rt.inc

.686
.xmm
include \masm32\macros\timers.asm			
LOOP_COUNT	= 10000


 l_htodw	PROTO : DWORD
 l_a2l       proto :dword 
Axhex2dw  PROTO : DWORD
Axa2l   proto :dword 
z_htodw PROTO :DWORD
StrCmpSSE	PROTO: DWORD, :DWORD

Axhex2dw_Unrolled PROTO:DWORD



.data

align  16
hexstring    db  "ABCDEF01",0

align 16
tabl1  dd   0,1,2,3,4,5,6,7,8,9
		  dd 	  39 Dup(0)
          dd   0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh

;align 16
;numstring          db  "1234543210",0
;align 16
;negnumstring   db  "-1234543210",0

.code
start:

	invoke GetCurrentThread
	invoke SetThreadAffinityMask,eax,1
	invoke Sleep,0
	
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@
	
	print "Test with case-insensitive variant of Lingo's hex2dword algo",13,10
	print "with using simple string in .data section (not in the end of the buffer).",13,10,13,10
	

	REPEAT 3

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke l_htodw, addr  hexstring
    counter_end
	     print str$(eax), 9, "cycles for  l_htodw - Lingo", 13, 10

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw_Unrolled, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for  Axhex2dw Unrolled - Alex", 13, 10


	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw, addr  hexstring
    counter_end
	     print str$(eax), 9, "cycles for  Axhex2dw - Alex", 13, 10
	     
	     print " ",13,10,13,10


	ENDM
	

	print " ", 13, 10
	print "Codesizes:", 13, 10
	print "l_htodw - Lingo:", 9
	mov   eax, l_htodw_endp
	sub	  eax, l_htodw
	print str$(eax), 13, 10

	print "Axhex2dw Unrolled - Alex:", 9
	mov   eax, Axhex2dw_endp_Unrolled
	sub	  eax, Axhex2dw_Unrolled
	print str$(eax), 13, 10
	
	print "Axhex2dw - Alex:", 9
	mov   eax, Axhex2dw_endp
	sub	  eax, Axhex2dw
	print str$(eax), 13, 10

	inkey "--- ok ---"
	exit


push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp



option prologue:none
option epilogue:none	
align 16
db 0,0,0,0,0,0,0,0
l_htodw   proc lpString:dword
	mov		edx, [esp+4]
	mov		eax, 1101111Y
	and      eax, [edx]
	mov		ecx, 11011111Y 
	jz			@f
	mov		eax, [tabl1+eax*4-40h]
	and      ecx, [edx+1]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+2]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+3]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+4]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+5]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+6]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
	mov		ecx, 11011111Y 
	and      ecx,[edx+7]
	jz			@f
	shl	    eax, 4
	add		eax, [tabl1+ecx*4-40h]
@@:
	ret		4
l_htodw  endp
l_htodw_endp:


align 16

db 0CCh,0CCh,0CCh,0CCh ; shifting to align main loop at 16 bytes
Axhex2dw    proc STDCALL lpszStr:DWORD
	mov edx,[esp+4]
	xor eax,eax
	mov [esp+4],edi
	
	jmp @preloop
	
	; main loop
	@@:	; loop aligned by 16 bytes
	and edi,1111Y
	shr ecx,6
	add edx,1
	shl eax,4
	lea edi,[edi+ecx*8]
	add eax,ecx
	add eax,edi
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx edi,byte ptr [edx]
	cmp ecx,0
	jnz @B
	@done:
	mov edi,[esp+4]
	ret 4
Axhex2dw    endp
Axhex2dw_endp:


align 16
Axhex2dw_Unrolled    proc STDCALL lpszStr:DWORD
;int 3
	mov edx,[esp+4]

	UNIT TEXTEQU <DWORD>
	
	@l1:
	movzx ecx,byte ptr [edx]
	cmp ecx,0
	jz @done
	mov eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+1]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+2]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+3]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+4]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+5]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+6]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+7]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	ret 4
	


	@done:
	shr eax,4
	ret 4

	.data
	align 16
	@table label UNIT
	;UNIT 30h dup (-1)
	UNIT 0,1,2,3,4,5,6,7,8,9
	UNIT 7 dup (-1)
	UNIT 10,11,12,13,14,15
	UNIT 26 dup(-1)
	UNIT 10,11,12,13,14,15
	.code _TEXT
		
Axhex2dw_Unrolled    endp
Axhex2dw_endp_Unrolled:

option prologue:prologuedef
option epilogue:epiloguedef

end start

